#! /home/song3/anaconda3/bin/python


import numpy as np
from matplotlib import pyplot as plt
import sys, struct
import os.path
import warnings
warnings.simplefilter('ignore')
from bitarray import bitarray

from bitio import bit_open




def readFile(filename):
    data = np.fromfile(filename,dtype=np.complex64)
    return data

def intToComplex(num):
    output = []
    modulation = np.array([1+1j,-1+1j,-1-1j,1-1j])
    for value in num:
        output.append(modulation[value])

    output = np.array(output)
    return output

def demod(signal):
    # import pdb;pdb.set_trace()
    constellation = np.array([1+1j,-1+1j,-1-1j,1-1j])
    numbers = [np.argmin(abs(constellation - s)) for s in signal]
    return numbers




def writeFile(filename,numbers):
    f = open(filename,"wb")
    bits = bitarray("".join(["{0:02b}".format(num) for num in numbers]))
    bits.tofile(f)
    # import pdb;pdb.set_trace()
    f.close()

if __name__ == "__main__":
    signal = readFile("./modulated_pic.dat")
    numbers = demod(signal)
    writeFile("./demod_pic1.jpg",numbers)



